## gnu-sather-pre4.tar.gz

=== Makefile ===
#------------------------------->  Makefile  <--------------------------------#
#- Copyright (C) 1994 by International Computer Science Institute            -#
#- This file is part of the GNU Sather package. It is free software; you may -#
#- redistribute  and/or modify it under the terms of the  GNU General Public -#
#- License (GPL)  as  published  by the  Free  Software  Foundation;  either -#
#- version 2 of the license, or (at your option) any later version.          -#
#- This  program  is distributed  in the  hope that it will  be  useful, but -#
#- WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY -#
#- or FITNESS FOR A PARTICULAR PURPOSE. See Doc/GPL for more details.        -#
#- The license text is also available from:  Free Software Foundation, Inc., -#
#- 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                     -#
#------------->  Please email comments to <bug-sather@gnu.org>  <-------------#

# Be sure to read the file Doc/Installation!
# You may need to set some variables in System/Common/CONFIG.proto
# to be appropriate to your system.
# Also make sure to adjust the paths in System/Platforms/X/Platform.module
# and System/Platforms/tcltk/Platform.module

export SATHER_HOME=$(shell pwd)

############################## VARIABLES TO SET ###############################

# Standard things
# CMP=cmp
RANLIB=ranlib
MV=mv
AR=ar
RM=rm -f
LN=ln -s
CP=cp

CPP=cpp -C -P
CC=gcc
GC_CC=$(CC)

# CC is only used for bootstrapping, check System/Common/CONFIG.proto if
# you want to change it for all Sather compilations

# Changes for Alpha
#CPP=/usr/ucb/cpp -C -P -DALPHA
#CC=gcc -DALPHA
#GC_CC=cc

# The name of the produced binaries
CS     =Bin/cs
BOOTCS =Boot/cs
BS     =Bin/bs

CS_OPT        =-verbose -O_fast -O_no_move_while -O_no_hoist_const -O_no_cse -only_reachable
CS_OPT_DEBUG  =-verbose -chk -C_flag -O -debug -debug_deterministic -debug_no_backtrace
CS_OPT_PROFILE=-verbose -only_reachable -optimize -C_flag -pg


# The list of platforms to install, in addition to "BOOT".
# "BOOT" intended to be the least common denominator required
# across all present and future platforms.  At the moment it
# uses the Boehm collector.
# This needs to edited to match the system. PLATFORMS is a comma
# separated list.
# If you intend to use threads, specify the matching parallel
# platform.

PLATFORMS=unix
#	  solaris,			\
#	  solaris_at/sparc_smp,		\
#	  solaris_at/sparc_myrinet,	\
#	  solaris/sparc_smp,		\
#	  solaris/sparc_myrinet,	\
#	  solaris/sparc_tcpip,		\
#	  solaris_at/i386_smp,		\
#	  hpux_at/hppa_smp,		\
#	  osf_at/axp_smp,		\
#	  unix,				\
#	  linux,			\
#	  linux/lwp,			\
#	  iris-4,			\
#	  freebsd,			\

# The platform to use if not overridden by a -<platform> option
# or the SATHER_PLATFORM environment variable
# Could be edited for a particular system
DEFAULT_PLATFORM=unix


################################ DEPENDENCIES #################################

# Make the boot compiler, compile the compiler with the boot compiler
# and install this new compiler. You need at least 60MB virtual memory
# for this. See Doc/Installation for details.
full: $(CS)


# Compile the boot compiler and use it as the compiler. This should
# work on most systems and does not require you to recompile the
# compiler itself. This is the default installation target.
small: $(BOOTCS)
	ln -s $(BOOTCS) $(CS)
	@echo; echo "...Boot compiler is now installation compiler." ; echo


# The compiler which ends up in Bin/ is the "fast" executable,
# which means that checking is turned off and optimizations are on.

# Some makes can't expand glob syntax with more than one *, so
# only specify one directory to expand instead of listing all of them.
# Watch out for this if you are modifying the compiler.

# This runs the C compiles after the Sather compiler instead of at
# the same time, to ease installation for those with small VM.

$(CS): system $(BOOTCS)
	@echo; echo "Creating C for installation compiler..." ; echo
	$(BOOTCS) $(CS_OPT) Compiler/cs.module -o $(CS) -only_C
	@echo; echo "Compiling C for installation compiler..." ; echo
	$(MAKE) -C $(CS).code

optional: $(BOOTCS)
	@echo "*************************************************************"
	@echo "        Trying to compile the optional Browser and Gui"
	@echo "*************************************************************"
	@echo "This step compiles the browser and provides the"
	@echo "        -dualgui and -debug_graphical compiler options:"
	@echo "If this step fails, it may be restarted by calling"
	@echo "      make optional"
	@echo "Requirements: "
	@echo "     Tcl7.4 and Tk4.0 for the Browser and Gui"
	@echo "     Sockets for the -dualgui and the -debug_graphical option"
	@echo "See Doc/Installation.html for more details."
	@echo "For errors, check:"
	@echo "      System/Platforms/tcltk/Platform.module "
	@echo "      System/Platforms/X/Platform.module "
	@echo "Also check System/Platforms/tcltk/startup.tcl"
	@echo "*************************************************************"
	@echo
	$(MAKE) $(BS)
	$(MAKE) dualgui

$(BS):
	@echo; echo "Creating C for Browser..." 
	$(CS) $(CS_OPT) Browser/browser.module -main BROWSER -o $(BS) -only_C
	@echo; echo "Compiling C for Browser..."
	$(MAKE) -C $(BS).code

# The following step creates the server for the dual process gui.
# The standard gui/browser do not need this step. However, it is almost
# certain that any system problems affecting the dual gui server will
# also affect that the standard gui and browser.
dualgui:	
	@echo; echo Creating server end for two-process Gui...; 
	@echo "****************************************************"; 
	@echo "Installing the server for the Dual process Gui, -dualgui"
	@echo "Required for use of the"
	@echo "     -dualgui and -debug_graphical"
	@echo "compiler options"
	@echo "See the notes in Doc/Installation.html for more details."
	@echo "****************************************************";
	$(MAKE) -C System/Platforms/dualgui

debug: $(BOOTCS)
	$(BOOTCS) $(CS_OPT_DEBUG) Compiler/cs.module -o $(CS) -only_C
	$(MAKE) -C $(CS).code

profile: 
	$(BOOTCS) $(CS_OPT_PROFILE) Compiler/cs.module -o $(CS) -only_C
	$(MAKE) -C cd $(CS).code

$(BOOTCS): system
	@echo; echo "Making boot compiler..." ; echo
	$(MAKE) CS='cs' CC='$(CC)' -C $(BOOTCS).code


# The rule for System/Common/CONFIG also makes the serial libraries,
# as well as making any platforms.

system: common library platforms

common:
	@ CC="$(CC)" GC_CC="$(GC_CC)" RANLIB="$(RANLIB)" CPP="$(CPP)"	\
	  MV="$(MV)" AR="$(AR)" RM="$(RM)" LN="$(LN)" CP="$(CP)"	\
	  export CC GC_CC RANLIB CPP MV AR RM LN CP;			\
	DEFAULT_PLATFORM='$(DEFAULT_PLATFORM)' PLATFORMS='$(PLATFORMS)' \
	$(MAKE) -C System/Common

library:
	@echo; echo -n "Making serial library: "
	@cd pLibrary; ./PP

platforms:
	@ CC="$(CC)" GC_CC="$(GC_CC)" RANLIB="$(RANLIB)" CPP="$(CPP)"	\
	  MV="$(MV)" AR="$(AR)" RM="$(RM)" LN="$(LN)" CP="$(CP)"	\
	  export CC GC_CC RANLIB CPP MV AR RM LN CP;			\
	echo;								\
	for i in `echo "BOOT",$(PLATFORMS) | tr , \ `; do		\
	  echo "Making platform $$i..." ;				\
	  $(MAKE) -C System/Platforms/$$i ;				\
	done							

info:
	cd Emacs && makeinfo sather.texinfo
	cd Emacs && makeinfo sather-tutorial.texinfo
	cd Emacs && makeinfo sather-mode.texinfo


################################### TESTING ###################################

# There are two tests.  The first is the test classes in the library,
# which is pretty straightforward.  The second is a full 
# double compilation of the compiler, which can take quite a while.

test:
	$(MAKE) -C Test test

# The full test does the following:
#
#    1. Compile using Bin/cs, with full checking on.
#    2. Compile using result.

testfull:
	$(MAKE) -C Test testfull

	
################################### CLEANING ##################################
		
clean-unneeded:
	$(RM) -r $(BS).code $(CS).code
	$(RM) $(BOOTCS) $(BOOTCS).code/*.o

clean: clean-unneeded
	$(MAKE) -C System/Common clean
	$(MAKE) -C System/pSather clean
	$(MAKE) -C Test clean
	 
	for i in System/Platforms/* ; do				\
	  if [ -f $$i/Makefile ] ; then $(MAKE) -C $$i clean ; fi	\
	done;
	
	$(RM) -r $(CS) Bin/bs $(CS).code Bin/bs.code
		
	$(RM) -r Doc/man/{whatis,cat1,windex}
	$(RM) Emacs/*.elc
	$(RM) Emacs/*.info Emacs/*.info??
	$(RM) Library/System/Socket/socket.sa
	$(RM) Library/Containers/stack.sa
	$(RM) Library/Containers/nr_stack.sa
	$(RM) Library/Containers/a_stack.sa
	$(RM) Library/Containers/nr_a_stack.sa
	$(RM) pLibrary/Containers/nr_stack.sa
	$(RM) pLibrary/Containers/nr_a_stack.sa

=== Test/Makefile ===
#------------------------------->  Makefile  <--------------------------------#
#- Copyright (C) 199x by International Computer Science Institute            -#
#- This file is part of the GNU Sather package. It is free software; you may -#
#- redistribute  and/or modify it under the terms of the  GNU General Public -#
#- License (GPL)  as  published  by the  Free  Software  Foundation;  either -#
#- version 2 of the license, or (at your option) any later version.          -#
#- This  program  is distributed  in the  hope that it will  be  useful, but -#
#- WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY -#
#- or FITNESS FOR A PARTICULAR PURPOSE. See Doc/GPL for more details.        -#
#- The license text is also available from:  Free Software Foundation, Inc., -#
#- 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                     -#
#------------->  Please email comments to <bug-sather@gnu.org>  <-------------#

CS             =Bin/cs
CS_OPT         =-chk -verbose -output_C
CS_PSATHER_OPT =-linux/lwp

TESTCS1     =./test-cs-first
TESTCS2     =./test-cs-second
TESTALL     =./test-all
TESTFULL    =./test-full
TESTPSATHER =./test-psather

####################### TESTING ########################

test: test-all

# There are two tests.  The first is the test classes in the library,
# which is pretty straightforward.  The second is a full 
# double compilation of the compiler, which can take quite a while.

test-all:
	@echo; echo Testing...; echo
	../$(CS) $(CS_OPT) test-all.module -main TEST_OBLIG -o $(TESTALL)
	$(TESTALL) > $(TESTALL).output

# The full test does the following:
#
#    1. Compile using Bin/cs, with full checking on.
#    2. Compile using result.
#    3. Clean up.

test-full:
	@echo; echo "Doing full test..." ; echo
	@echo; echo "Compiling 1st..." ; echo
	../$(CS) $(CS_OPT) ../Compiler/cs.module -o $(TESTCS1)
	@echo; echo "Compiling 2nd..." ; echo
	$(TESTCS1) $(CS_OPT) ../Compiler/cs.module -o $(TESTCS2)
	
	$(TESTCS2) $(CS_OPT) test-all.module -o $(TESTFULL)
	$(TESTFULL) > $(TESTFULL).output
	
	@ CC="$(CC)" RANLIB="$(RANLIB)" CPP="$(CPP)" MV="$(MV)"	\
	  AR="$(AR)" RM="$(RM)" LN="$(LN)" CP="$(CP)"		\
	  export CC RANLIB CPP MV AR RM LN CP;			\
	for i in `echo $(PLATFORMS) | tr , \ ` ; do		\
	  echo "Testing platform $$i..." ;			\
	  $(MAKE) -C ../System/Platforms/$$i test ;		\
	done
	
	@echo; echo "Everything okay" ; echo

test-psather:
	../$(CS) $(CS_OPT) $(CS_PSATHER_OPT) test-psather.module -o $(TESTPSATHER)
	$(TESTPSATHER) > $(TESTPSATHER).output

clean:
	rm -fr cs.first cs.first.code cs.second cs.second.code
	rm -fr $(TESTALL) $(TESTALL).code $(TESTALL).output
	rm -fr $(TESTFULL) $(TESTFULL).code $(TESTFULL).output
	rm -fr $(TESTPSATHER) $(TESTPSATHER).code $(TESTPSATHER).output

# These test rules are used at the ICSI. If you work on the compiler they
# may be useful for you too, but you will probably have to hack the perl
# scripts in Test and Test/TestPrg/PROG (they are adapted to the 
# specific way files and home directories are set up at ICSI).

testcommit: SYSTEM prepare_test 
	@ CC="$(CC)" RANLIB="$(RANLIB)" CPP="$(CPP)" MV="$(MV)"	\
	  AR="$(AR)" RM="$(RM)" LN="$(LN)" CP="$(CP)"		\
	  export CC RANLIB CPP MV AR RM LN CP;			\
	for i in solaris					\
	         solaris/sparc_smp				\
		 solaris/sparc_tcpip				\
	         solaris_at/sparc_smp				\
		 solaris_at/sparc_myrinet; do			\
	  echo "Making platform $$i..." ;			\
	  $(MAKE) -C System/Platforms/$$i			\
	done
	
	./do_test solaris solaris/sparc_smp solaris/sparc_tcpip \
	          solaris_at/sparc_smp solaris_at/sparc_myrinet

testcomplete:
	./do_test `echo $(PLATFORMS) | tr '",' '  '`

testplatform:
	@ CC="$(CC)" RANLIB="$(RANLIB)" CPP="$(CPP)" MV="$(MV)"	\
	  AR="$(AR)" RM="$(RM)" LN="$(LN)" CP="$(CP)"		\
	  export CC RANLIB CPP MV AR RM LN CP;			\
	$(MAKE) -C ../System/Platforms/$(PLATFORM)
	./do_test `echo $(PLATFORM)`

=== System/Common/Siva/Makefile ===
#------------------------------->  Makefile  <--------------------------------#
#- Copyright (C) 199x by International Computer Science Institute            -#
#- This file is part of the GNU Sather package. It is free software; you may -#
#- redistribute  and/or modify it under the terms of the  GNU General Public -#
#- License (GPL)  as  published  by the  Free  Software  Foundation;  either -#
#- version 2 of the license, or (at your option) any later version.          -#
#- This  program  is distributed  in the  hope that it will  be  useful, but -#
#- WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY -#
#- or FITNESS FOR A PARTICULAR PURPOSE. See Doc/GPL for more details.        -#
#- The license text is also available from:  Free Software Foundation, Inc., -#
#- 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                     -#
#------------->  Please email comments to <bug-sather@gnu.org>  <-------------#

# Platforms:
#
#   serial_boehm         - Built using Brahma "serial"; uses Boehm collector
#   serial_solaris       - Built using Brahma "serial"; ultrasparc/solaris
#   smp_solaris          - Built using Brahma "smp_solaris"; ultrasparc/solaris
#
# The Siva archive file may be created for a given platform "foo" like this:
#
#   make foo INSTALL=xxx.a

# The location of the Brahma directory
BR=../Brahma

# The location of the Boehm source
#BOEHM=../GC

# The installation location of the Boehm GC
#GC_A=../gc.a

all:
	@echo There is no default make rule: read the Siva Makefile.

beware:
	@if [ -z "$(INSTALL)" ]; then \
	   echo "You forgot to set the INSTALL location."; \
	   exit 1; \
	fi

$(BR)/lib/serial.a:
	@echo Making Brahma library "serial"...
	cd $(BR); $(MAKE) serial INSTALL=lib/serial.a

#This is to get around `ar's inability to repack archive files
BOEHM_OBJ= allchblk.o alloc.o blacklst.o checksums.o dbg_mlc.o dyn_load.o finalize.o headers.o mach_dep.o malloc.o mark.o mark_rts.o misc.o new_hblk.o obj_map.o os_dep.o ptr_chck.o reclaim.o solaris_threads.o stubborn.o typd_mlc.o
SERIAL_BR_OBJ= brahma.o

#$(GC_A):
#	@echo Making Boehm collector...
#	cd $(BOEHM); $(MAKE) CFLAGS='-O3 -DSILENT -DNO_SIGNALS' gc.a; mv gc.a ..

serial_boehm: beware serial_boehm.c serial_boehm.h $(BR)/lib/serial.a
# $(GC_A)
	gcc -O3 -DBR_SERIAL -I$(BR) -DSI_SERIAL_BOEHM -c siva.c
	@echo Creating library $(INSTALL)...
	ar x $(GC_A)
	ar x $(BR)/lib/serial.a
	ar rus $(INSTALL) siva.o $(BOEHM_OBJ) $(SERIAL_BR_OBJ)
	rm -f $(BOEHM_OBJ) $(SERIAL_BR_OBJ)

#This is to get around `ar's inability to repack archive files
SERIAL_SOLARIS_OBJ= brahma.o

serial_solaris: beware serial_solaris.c serial_solaris.h zones.c zones.h $(BR)/lib/serial.a
	gcc -O3 -DBR_SERIAL -I$(BR) -DSI_SERIAL_SOLARIS -c siva.c
	@echo Creating library $(INSTALL)...
	ar x $(BR)/lib/serial.a
	ar rus $(INSTALL) siva.o $(SERIAL_SOLARIS_OBJ)
	rm -f $(SERIAL_SOLARIS_OBJ)

serial_solaris_hyper: beware serial_solaris_hyper.c serial_solaris_hyper.h zones.c zones.h $(BR)/lib/serial.a
	gcc -O3 -DBR_SERIAL -I$(BR) -DSI_SERIAL_SOLARIS_HYPER -c siva.c
	@echo Creating library $(INSTALL)...
	ar x $(BR)/lib/serial.a
	ar rus $(INSTALL) siva.o $(SERIAL_SOLARIS_OBJ)
	rm -f $(SERIAL_SOLARIS_OBJ)

#This is to get around `ar's inability to repack archive files
# Commented the .so files out as they tend to migrate from version to version
# (In particular, this depends on the correct setting of LD_LIBRARY_PATH)
# and no longer compiles with ICSI's current environment
# Boris Wed Oct 15 22:42:20 PDT 1997
#SMP_SOLARIS_OBJ= brahma.o libthread.so libkstat.so
SMP_SOLARIS_OBJ= brahma.o

$(BR)/lib/smp_solaris.a:
	@echo Making Brahma library "smp_solaris"...
	cd $(BR); $(MAKE) smp_solaris INSTALL=lib/smp_solaris.a

smp_solaris: beware smp_solaris.c smp_solaris.h zones.c zones.h $(BR)/lib/smp_solaris.a
	gcc -O3 -DBR_SMP_SOLARIS -I$(BR) -DSI_SMP_SOLARIS -c siva.c
	@echo Creating library $(INSTALL)...
	ar x $(BR)/lib/smp_solaris.a
	ar rus $(INSTALL) siva.o $(SMP_SOLARIS_OBJ)
	rm -f $(SMP_SOLARIS_OBJ)

# Don't use -O3 to avoid interprocedual opts...
benchmark: serial_boehm.a benchmark.c
	gcc -O2 -DBR_SERIAL -I$(BR) -DSI_SERIAL_BOEHM benchmark.c smp_solaris.a -o benchmark

clean:
	rm -f *.a *.o *.so benchmark
	cd $(BR); $(MAKE) clean
#	cd $(BOEHM); $(MAKE) clean

=== System/Platforms/X/Makefile ===
#------------------------------->  Makefile  <--------------------------------#
#- Copyright (C) 199x by International Computer Science Institute            -#
#- This file is part of the GNU Sather package. It is free software; you may -#
#- redistribute  and/or modify it under the terms of the  GNU General Public -#
#- License (GPL)  as  published  by the  Free  Software  Foundation;  either -#
#- version 2 of the license, or (at your option) any later version.          -#
#- This  program  is distributed  in the  hope that it will  be  useful, but -#
#- WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY -#
#- or FITNESS FOR A PARTICULAR PURPOSE. See Doc/GPL for more details.        -#
#- The license text is also available from:  Free Software Foundation, Inc., -#
#- 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                     -#
#------------->  Please email comments to <bug-sather@gnu.org>  <-------------#

all:	
	$(SATHER_HOME)/Bin/cs DualGuiServer.module	
clean:
test:

=== System/Platforms/dualgui/Makefile ===
#------------------------------->  Makefile  <--------------------------------#
#- Copyright (C) 199x by International Computer Science Institute            -#
#- This file is part of the GNU Sather package. It is free software; you may -#
#- redistribute  and/or modify it under the terms of the  GNU General Public -#
#- License (GPL)  as  published  by the  Free  Software  Foundation;  either -#
#- version 2 of the license, or (at your option) any later version.          -#
#- This  program  is distributed  in the  hope that it will  be  useful, but -#
#- WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY -#
#- or FITNESS FOR A PARTICULAR PURPOSE. See Doc/GPL for more details.        -#
#- The license text is also available from:  Free Software Foundation, Inc., -#
#- 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                     -#
#------------->  Please email comments to <bug-sather@gnu.org>  <-------------#

# Generate the server end for the dual process gui
all:	
	$(SATHER_HOME)/Boot/cs GuiServer.module -main GUI_SERVER_END -o dual_gui_server  -verbose -output_C
clean:
test:

=== System/pSather/am/Makefile ===
#------------------------------->  Makefile  <--------------------------------#
#- Copyright (C) 199x by International Computer Science Institute            -#
#- This file is part of the GNU Sather package. It is free software; you may -#
#- redistribute  and/or modify it under the terms of the  GNU General Public -#
#- License (GPL)  as  published  by the  Free  Software  Foundation;  either -#
#- version 2 of the license, or (at your option) any later version.          -#
#- This  program  is distributed  in the  hope that it will  be  useful, but -#
#- WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY -#
#- or FITNESS FOR A PARTICULAR PURPOSE. See Doc/GPL for more details.        -#
#- The license text is also available from:  Free Software Foundation, Inc., -#
#- 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                     -#
#------------->  Please email comments to <bug-sather@gnu.org>  <-------------#

LIBNAME=libam.a
LIBDIR=../lib
HEADERNAME=am.h
HEADERDIR=../include
#Nobbi:
PCFLAGS=-g -Wall -DAM_THREADS -DLWP -I../lwp
PLIBS=../lwp/liblwp.a

MCFLAGS=$(CFLAGS) $(PCFLAGS) $(AM) -I$(HEADERDIR)
LIBS=-L$(LIBDIR) $(PLIBS)

VERSION=0.08

include ../Make.config

################################################################
## You probably won't need to change anything below this line ##
################################################################

LWPFILES=386bsd.c 386bsd.h Makefile arch.lc arch.lh bm.c clk.c \
	linux.c linux.h lwp.c lwp.h mips.c mips.h producer.c queue.c \
	sem.c sig.c sun3.c sun3.h sun4.c sun4.h timer.c timing.c timing.h
AMMAKEFILE=Makefile
AMREADME=README
AMCFILES=am.c tcpam.c lam.c meiam.c am_add.c am.h am_int.h mesg.c am_nothread.c am_lwp.c am_solaris.c
AMFILES=LICENSE THREADS CHANGES prun pkill tcpam_config
LIC=LICENSE EMAIL

OBJ=am.o tcpam.o am_add.o meiam.o lam.o am_lwp.o am_solaris.o am_nothread.o $(SPECIAL_AM_FILES)

test: mesg Makefile
#	@-echo "*** The Library is now beeing tested."
#	@-echo "*** On a slow system the test will run for several minutes"
#	$(AM_TEST)

install: $(LIBNAME) Makefile
	$(CP) $(LIBNAME) $(LIBDIR)/$(LIBNAME)
	$(CP) am.h $(HEADERDIR)/$(HEADERNAME)

clean:
	$(RM) -f *.o libam.a SPEC mesg

mesg: mesg.o $(LIBNAME) am.h $(OBJ) $(LWP)
	$(CC) $(MCFLAGS) -o mesg mesg.o $(OBJ) $(LIBS)


$(LIBNAME): $(OBJ) Makefile
	$(RM) -f $(LIBNAME)
	$(AR) rc $(LIBNAME) $(OBJ)
	$(RANLIB) $(LIBNAME)
	echo VERSION=$(VERSION) > SPEC
	echo MCFLAGS=$(MCFLAGS) >> SPEC
	echo LIBS=$(LIBS) >> SPEC

am.o:		Makefile am.c am.h am_int.h 
mesg.o:		Makefile mesg.c am.h 
am_nothread.o:	Makefile am_nothread.c am.h am_int.h 
am_lwp.o:	Makefile am_lwp.c am.h am_int.h 
am_solaris.o:	Makefile am_solaris.c am.h am_int.h 
tcpam.o:	Makefile tcpam.c am.h am_int.h 
am_add.o:	Makefile am_add.c am.h am_int.h 
lam.o:		Makefile lam.c am.h am_int.h # ../config/lanai/lcp/ep.h ../config/lanai/lcp/ifc.h 
meiam.o:	Makefile am.h am_int.h 

.c.o:
	$(CC) $(MCFLAGS) -c $*.c

=== System/pSather/lwp/Makefile ===
#------------------------------->  Makefile  <--------------------------------#
#- Copyright (C) 1994 by International Computer Science Institute            -#
#- This file is part of the GNU Sather package. It is free software; you may -#
#- redistribute  and/or modify it under the terms of the  GNU General Public -#
#- License (GPL)  as  published  by the  Free  Software  Foundation;  either -#
#- version 2 of the license, or (at your option) any later version.          -#
#- This  program  is distributed  in the  hope that it will  be  useful, but -#
#- WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY -#
#- or FITNESS FOR A PARTICULAR PURPOSE. See Doc/GPL for more details.        -#
#- The license text is also available from:  Free Software Foundation, Inc., -#
#- 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                     -#
#------------->  Please email comments to <bug-sather@gnu.org>  <-------------#

CC=gcc
AR=ar
CFLAGS=-Wall -g  -O2
include ../Make.config

OBJ=		lwp.o sem.o queue.o clk.o sig.o timing.o

all:	timer producer

install:	liblwp.a
		cp liblwp.a ../lib
		cp lwp.h ../include

producer:	producer.o liblwp.a
		gcc $(CFLAGS) -o producer producer.o liblwp.a

timer:	timer.o liblwp.a
	gcc $(CFLAGS) -o timer timer.o liblwp.a

liblwp.a:	$(OBJ) lwp.h
		$(AR) rc liblwp.a $(OBJ)
		$(RANLIB) liblwp.a

.c.o:;	$(CC) -DLWP -c $(CFLAGS) $*.c

bm.o : ../Make.config bm.c lwp.h timing.h arch.lh 
clk.o : ../Make.config clk.c lwp.h timing.h arch.lh 
lwp.o : ../Make.config lwp.c lwp.h timing.h arch.lh arch.lc 
producer.o : ../Make.config producer.c lwp.h timing.h arch.lh 
queue.o : ../Make.config queue.c lwp.h timing.h arch.lh 
sem.o : ../Make.config sem.c lwp.h timing.h arch.lh 
sig.o : ../Make.config sig.c lwp.h timing.h arch.lh
timing.o : ../Make.config timing.c timing.h 
timer.o : ../Make.config timer.c lwp.h timing.h arch.lh 
producer.o : ../Make.config producer.c lwp.h timing.h arch.lh 

clean:
	rm -f *.o timer producer liblwp.a

=== System/pSather/pSather/Makefile ===
#------------------------------->  Makefile  <--------------------------------#
#- Copyright (C) 199x by International Computer Science Institute            -#
#- This file is part of the GNU Sather package. It is free software; you may -#
#- redistribute  and/or modify it under the terms of the  GNU General Public -#
#- License (GPL)  as  published  by the  Free  Software  Foundation;  either -#
#- version 2 of the license, or (at your option) any later version.          -#
#- This  program  is distributed  in the  hope that it will  be  useful, but -#
#- WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY -#
#- or FITNESS FOR A PARTICULAR PURPOSE. See Doc/GPL for more details.        -#
#- The license text is also available from:  Free Software Foundation, Inc., -#
#- 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                     -#
#------------->  Please email comments to <bug-sather@gnu.org>  <-------------#

#
# Some install variables
#
include ../pSather.options
include ../Make.config
HEADERDIR=../include
LIBDIR=../lib
CFLAGS=$(PCFLAGS) $(PSATHER) -I$(HEADERDIR)

OBJ=alloc.o exceptions.o locks.o psather.o attach.o \
    debug.o trace.o import.o cache.o stat.o fakegc.o parloop.o
HEADER= debug.h exceptions.h local.h locks.h pSather.h

libpSather.a:	$(OBJ)
	$(RM) -f libpSather.a
	$(AR) rc libpSather.a $(OBJ)
	$(RANLIB) libpSather.a

../lib/libam.a:	../am.options
	cd ../am; $(MAKE) install

install: libpSather.a
	$(CP) libpSather.a $(LIBDIR)
	$(CP) pSather.h $(HEADERDIR)
	$(CP) simple-par.h $(HEADERDIR)
	$(RANLIB) $(LIBDIR)/libpSather.a
#	echo "-lpSather -lam $(PLIBS)" > ../libraries
#	echo "$(PCFLAGS)" | sed 's/-Wall//' > ../flags

clean:
	rm -f *.o
	rm -f test
	rm -f libpSather.a
	rm -f .depend

.c.o:;
	$(CC) $(CFLAGS) -c $*.c

.depend:;
	gcc -MM $(CFLAGS) $(OBJ:.o=.c) | sed 's/:/: ..\/Make.config Makefile ..\/pSather.options/' >> .depend

-include .depend

=== System/Common/ActiveThreads/src/Makefile ===
#------------------------------->  Makefile  <--------------------------------#
#- Copyright (C) 199x by International Computer Science Institute            -#
#- This file is part of the GNU Sather package. It is free software; you may -#
#- redistribute  and/or modify it under the terms of the  GNU General Public -#
#- License (GPL)  as  published  by the  Free  Software  Foundation;  either -#
#- version 2 of the license, or (at your option) any later version.          -#
#- This  program  is distributed  in the  hope that it will  be  useful, but -#
#- WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY -#
#- or FITNESS FOR A PARTICULAR PURPOSE. See Doc/GPL for more details.        -#
#- The license text is also available from:  Free Software Foundation, Inc., -#
#- 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                     -#
#------------->  Please email comments to <bug-sather@gnu.org>  <-------------#

# Makefile for Active Threads libraries and tests
#CC	      = gcc -ansi -Wall -pedantic

#turned off -ansi for assembly
CC	      = gcc 
AR	      = ar
#MAKE	      = gmake
VPATH		= .:../include

SCHED		= ../schedulers
MD		= ../md
LIB		= ../lib
TESTS		= ../tests

#
# Need to include from the current directory because "qt.h"
# will include <qtmd.h>.
#
# At least -O or higher is needed for inlining to work properly
# in gcc

#To enable inlining, comment out DEBUG_FLAGS
#If you do this, make sure -O or higher is used 
#(gcc fails to do inilining otherwise)
INC_DIR	      = -I../include -I$(MD)/$(ARCH) #DEBUG_FLAGS   = -g -DAT_NO_INLINE
DEBUG_FLAGS   = -O3
CFLAGS	      = $(INC_DIR) $(DEBUG_FLAGS)

HDRS	      = qt.h \
		$(MD)/$(ARCH)/qtmd.h \
		$(MD)/$(ARCH)/utils.h \
		$(MD)/$(ARCH)/lwp.h \
		$(MD)/$(ARCH)/md-atomic.h \
		at.h \
		at-inline.h \
		at-int.h \
		at-lwp.h \
		mutex.h \
		cond.h \
		rw.h \
		pool.h \
		p_pool.h \
		sema.h \
		barrier.h \
		spinlock.h \
		thread.h \
		wrappers.h \
		bundle.h \
		const.h

LDFLAGS	      = $(CFLAGS)

LIBS	      = libat.a libqt.a libschedulers.a

LINKER	      = $(CC)

MAKEFILE      = Makefile

OBJS	      = $(MD)/$(ARCH)/qtmdb.o \
		meas.o


# Temporarily disabled hardware feedback */
#QTOBJS	      =	qt.o $(MD)/$(ARCH)/qtmds.o $(MD)/$(ARCH)/hwperf.o 
QTOBJS	      =	qt.o $(MD)/$(ARCH)/qtmds.o

ATOBJS	      =	at.o mutex.o cond.o rw.o pool.o p_pool.o sema.o barrier.o $(MD)/$(ARCH)/lwp.o thread.o \
		wrappers.o 

sparc-solaris:		
		$(MAKE) all ARCH=sparc-solaris DEBUG_FLAGS=$(DEBUG_FLAGS)
		$(MAKE) tests ARCH=sparc-solaris

i386-solaris:	
		$(MAKE) all ARCH=i386-solaris

axp-osf:
		$(MAKE) all ARCH=axp-osf

hppa-hpux:
		$(MAKE) all ARCH=hppa-hpux

mips-irix5:		
		$(MAKE) all ARCH=mips-irix5 DEBUG_FLAGS=$(DEBUG_FLAGS)
		$(MAKE) tests ARCH=mips-irix5

all:		beware $(LIB)/libqt.a $(LIB)/libat.a $(LIB)/libschedulers.a

beware:		
#		@if [ -z "$(ARCH)" ]; then \
#		echo "---------------------------------------------"; \
#		echo "You forgot to set ARCH"; \
#		echo "Possible choices: sparc-solaris, i386-solaris"; \
#		echo "---------------------------------------------"; \
#		exit 1; \
#		fi
$(LIB)/libqt.a:	$(QTOBJS) 
		$(AR) crvs $(LIB)/libqt.a $(QTOBJS)
#		ranlib $(LIB)/libqt.a

clean:
		rm -f *.o 
		rm -f $(MD)/*/*.o
		rm -f $(SCHED)/*.o
		rm -f $(LIB)/libqt.a $(LIB)/libat.a $(LIB)/libschedulers.a
		cd $(TESTS); $(MAKE) clean

cleanup:
		rm -f *.o 
		rm -f $(SCHED)/*.o
		rm -f $(LIB)/libqt.a $(LIB)/libat.a $(LIB)/libschedulers.a

QT_H =		qt.h $(QTMD_H)
QTMD_H =	$(MD)/$(ARCH)/qtmd.h

###
qtmdb.o: qtmdb.s b.h
meas.o: meas.c /usr/include/stdio.h $(QT_H) b.h at.h
qt.o: qt.c $(QT_H)
at.o: at.c at.h $(QT_H)
#$(MD)/$(ARCH)/qtmds.o: $(MD)/$(ARCH)/qtmds.s
#	$(CC) -c -g $(MD)/$(ARCH)/qtmds.s -o $(MD/$(ARCH)/qtmds.o

$(MD)/$(ARCH)/qtmds.o: $(MD)/$(ARCH)/qtmds.s
		cd $(MD)/$(ARCH); $(MAKE) qtmds.o

$(MD)/$(ARCH)/hwperf.o: 
		cd $(MD)/$(ARCH); $(MAKE) hwperf.o

at.h:		at-inline.h wrappers.h mutex.h cond.h rw.h sema.h barrier.h 
at-int.h:	qt.h spinlock.h at.h at-inline.h at-lwp.h mutex.h cond.h rw.h\
		pool.h p_pool.h $(MD)/$(ARCH)/utils.h thread.h wrappers.h \
		const.h 

pool.h:		spinlock.h wrappers.h
p_pool.h:	pool.h spinlock.h wrappers.h
bundle.h:	at-int.h 

at.o:		at-int.h at.c
mutex.o:	at-int.h mutex.c 
cond.o:		at-int.h cond.c 
rw.o:		at-int.h rw.c 
pool.o:		pool.h pool.c
p_pool.o:	p_pool.h p_pool.c
sema.o:		at-int.h sema.c 
barrier.o:	at-int.h barrier.c 

#$(MD)/$(ARCH)/lwp.o:	$(MD)/$(ARCH)/lwp.h wrappers.h $(MD)/$(ARCH)/lwp.c
#		$(CC) -c $(CFLAGS) $(MD)/$(ARCH)/lwp.c -o $(MD)/$(ARCH)/lwp.o

$(MD)/$(ARCH)/lwp.o:	$(MD)/$(ARCH)/lwp.h wrappers.h $(MD)/$(ARCH)/lwp.c
		cd $(MD)/$(ARCH); $(MAKE) lwp.o 
thread.o:	at-int.h thread.c
wrappers.o:	spinlock.h wrappers.c


$(LIB)/libat.a:	at.o $(MD)/$(ARCH)/lwp.o wrappers.o pool.o p_pool.o thread.o mutex.o cond.o sema.o barrier.o rw.o $(HDRS) 
		$(AR) crvs $(LIB)/libat.a at.o $(MD)/$(ARCH)/lwp.o wrappers.o pool.o p_pool.o thread.o mutex.o cond.o rw.o sema.o barrier.o 
#		ranlib $(LIB)/libat.a

$(LIB)/libschedulers.a: 
		cd $(SCHED); $(MAKE) ARCH=$(ARCH) DEBUG_FLAGS="$(DEBUG_FLAGS)"

tests:		
		cd $(TESTS); $(MAKE) tests ARCH=$(ARCH)



at_merge:	all
		$(MAKE) all
		cd $(TESTS); $(MAKE) at_merge ARCH=$(ARCH)

=== debian/changelog ===
sather (1.2.pre4-1) unstable; urgency=low

  * New upstream version

 -- Norbert Nemec <nobbi@gnu.org>  Tue, 14 Sept 1999 15:21:50 +0200

sather (1.2-1) unstable; urgency=low

  * New upstream version ( Working towards GNU Sather )

 -- Norbert Nemec <nobbi@gnu.org>  Sun, 25 Jul 1999 16:21:50 +0200

sather (1.2b-2) unstable; urgency=low

  * Fixing stuff up to get first preliminary version out.

 -- Norbert Nemec <nobbi@gnu.org>  Thu, 20 May 1999 22:43:08 +0200

sather (1.2b-1) unstable; urgency=low

  * Removed GC from package, now depends on libgc4
  * Initial Release.

 -- Norbert Nemec <nobbi@gnu.org>  Tue,  23 Feb 1999 13:07:50 +0100

Local variables:
mode: debian-changelog
add-log-mailing-address: "nobbi@gnu.org"
End:

=== debian/control ===
Source: sather
Section: devel
Priority: optional
Maintainer: Norbert Nemec <nobbi@gnu.org>
Standards-Version: 2.4.0.0

Package: sather
Architecture: any
Depends: ${shlibs:Depends}
Suggests: tk4.2-dev
Description: Sather compiler
 Compiler and programming environment for Sather:
 Sather is an object oriented language which designed to be simple,
 efficient, safe, and non-proprietary. It aims to meet the needs of
 modern research groups and to foster the development of a large,
 freely available, high-quality library of efficient well-written
 classes for a wide variety of computational tasks. It was originally
 based on Eiffel but now incorporates ideas and approaches from several
 languages. One way of placing it in the "space of languages" is to say
 that it attempts to be as efficient as C, C++, or Fortran, as elegant
 and safe as Eiffel or CLU, and to support higher-order functions as
 well as Common Lisp, Scheme, or Smalltalk.

Package: sather-lwp
Architecture: any
Depends: sather
Description: pSather - Parallel extensions to the Sather environment
 This is based on LWP, a implementation of user-space threads, which is also
 included in this package.

Package: sather-doc
Architecture: all
Suggests: sather, www-browser, postscript-viewer, info-browser
Description: Documentation for the object oriented language Sather
 HTML, PostScript, Info documentation for the object oriented language
 Sather.

Package: sather-elisp
Architecture: all
Depends: emacsen
Suggests: sather
Description: Emacs mode for editing Sather programs
 Emacs mode for editing Sather programs.

Package: sather-browser
Architecture: any
Depends: sather, tcl7.6, tk4.2, c-shell, tclsh
Description: A Tcl/Tk based class browser for Sather.
 A class browser for the OO-language Sather, written in Sather, using the 
 Tcl/Tk toolkit.

=== debian/rules ===
#!/usr/bin/make -f
############################################################################
# Made with the aid of dh_make, by Craig Small
# Based on sample debian/rules that uses debhelper,  by Joey Hess.
# Some lines taken from debmake, by Cristoph Lameter.
# Based on a earlier version by Shugo Maeda
# Completely reworked and turned upside down by Norbert Nemec
############################################################################

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

pwd := $(shell pwd)

###################

sather_root  := $(pwd)/debian/tmp
sather_home  := $(sather_root)/usr/lib/Sather
sather_bin   := $(sather_root)/usr/bin

sather_files := Bin/cs \
		Library \
		System/FORBID \
		System/Debug \
		System/Common/*.c \
		System/Common/*.h \
		System/Common/*.module \
		System/Common/CONFIG \
		System/Platforms/X \
		System/Platforms/dualgui \
		System/Platforms/f77 \
		System/Platforms/gui \
		System/Platforms/linux \
		System/Platforms/tcltk

###################

lwp_root    := $(pwd)/debian/sather-lwp
lwp_home    := $(lwp_root)/usr/lib/Sather

###################

doc_root    := $(pwd)/debian/sather-doc
doc_dir     := $(doc_root)/usr/doc/sather-doc
doc_info    := $(doc_root)/usr/info

info_files  := sather.info sather.info-1 sather.info-2 sather-tutorial.info

###################

el_root    := $(pwd)/debian/sather-elisp
el_install := $(el_root)/usr/lib/emacsen-common/packages/install
el_remove  := $(el_root)/usr/lib/emacsen-common/packages/remove
el_dir     := $(el_root)/usr/share/emacs/site-lisp/sather-elisp
el_etc     := $(el_root)/etc/emacs/site-start.d
el_info    := $(el_root)/usr/info

el_files   := Emacs/sather.el Emacs/sather-module.el Emacs/sather-lib.el

###################

browser_root := $(pwd)/debian/sather-browser
browser_home := $(browser_root)/usr/lib/Sather

browser_files := Bin/bs Bin/gen_html Browser/Tcl Browser/Web

############################################################################

all:

###################

build: build-force build-stamp
build-force:
	rm -f build-stamp
build-stamp:
#	dh_testversion
	dh_testdir
	dh_testroot
	
	$(MAKE) DEFAULT_PLATFORM="linux" PLATFORMS="linux,linux/lwp" Bin/cs
	$(MAKE) DEFAULT_PLATFORM="linux" PLATFORMS="linux,linux/lwp" Bin/bs
	$(MAKE) DEFAULT_PLATFORM="linux" PLATFORMS="linux,linux/lwp" info
	
	touch build-stamp

###################

install: install-force install-stamp
install-force:
	rm -f install-stamp
install-stamp: build-stamp
#	dh_testversion
	dh_testdir
	dh_testroot
	
	##### General preparations for installing
	
	dh_clean -k
	dh_installdirs
	
	##### Installing: sather
	
	for file in $(sather_files); do \
	  cp -a -P $$file $(sather_home); \
	done
	
	rm -r `find $(sather_root) "(" -name "*.config" -o -name "CVS" -o -name "Makefile" ")"`
	rm -r $(sather_home)/System/Platforms/linux/lwp
		
	install -m755 debian/bin-wrapper $(sather_home)/Bin
	
	ln -s ../lib/Sather/Bin/bin-wrapper $(sather_root)/usr/bin/cs
	
	dh_installmanpages -psather bs.1 shortflat.1 tgrep.1
	dh_installchangelogs -psather Doc/Changes
	
	##### Installing: sather-lwp
	
	cp -a -P System/Platforms/linux/lwp $(lwp_home)
	rm $(lwp_home)/System/Platforms/linux/lwp/Makefile
	cp -a -P System/Common/Brahma/lib/lwp_linux.a $(lwp_home)
	cp -a -P System/Common/Brahma/lwp_linux/lwp_linux.h $(lwp_home)
	cp -a -P System/Common/Brahma/brahma.h $(lwp_home)
	cp -a -P System/pSather/lib $(lwp_home)
	cp -a -P System/pSather/include $(lwp_home)
	
	cp -a -P pLibrary $(lwp_home)
	
	rm -r `find $(lwp_root) "(" -name "*.config" -o -name "CVS" -o -name "Makefile" -o -name "PP" ")"`
	
	##### Installing: sather-browser
	
	for file in $(browser_files); do \
	  cp -a $$file $(browser_home)/$$file; \
	done
	
	ln -s ../lib/Sather/Bin/bin-wrapper $(browser_root)/usr/bin/bs
	
	dh_installmanpages -psather-browser cs.1 shortflat.1 tgrep.1
	dh_installchangelogs -psather-browser
	
	##### Installing: sather-doc
	
	for file in $(info_files); do \
	    cp -a Emacs/$$file $(doc_info); \
	done
	
	cp -a Doc/Gui/Doc.fmk.ps $(doc_dir)/gui.ps
	
	dh_installchangelogs -psather-doc
	
	# Installing: sather-elisp
	
	cp -a $(el_files) $(el_dir)
	cp -a debian/50sather.el $(el_etc)
	cp -a Emacs/sather-mode.info $(el_info)
	
	dh_installchangelogs -psather-elisp Emacs/ChangeLog
	
	
	##### General finishing commands
	
	dh_installdocs
	dh_installemacsen
	
#	dh_installexamples
#	dh_installmenu
	
	dh_strip
	dh_compress
	dh_fixperms
	
	touch install-stamp

###################
	
# Build architecture-independent files here.
binary-indep: install-stamp
#	dh_testversion
	dh_testdir
	dh_testroot
	
#	dh_suidregister -i
	dh_installdeb -i
	dh_shlibdeps -i
	dh_gencontrol -i
	dh_makeshlibs -i
	dh_md5sums -i
	dh_builddeb -i


# Build architecture-dependent files here.
binary-arch: install-stamp
#	dh_testversion
	dh_testdir
	dh_testroot
	
#	dh_suidregister -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_makeshlibs -a
	dh_md5sums -a
	dh_builddeb -a


binary: binary-indep binary-arch

###################

clean:
#	dh_testversion
	dh_testdir
	dh_testroot
	
	rm -f *-stamp
	
	$(MAKE) clean
	
	dh_clean

###################
		
test:
#	dh_testversion
	dh_testdir
	dh_testroot

source diff:                                                                  
	@echo >&2 'source and diff are obsolete - use dpkg-source -b'; false

.PHONY: build build-force install install-force \
        binary-indep binary-arch binary \
	clean test
        
############################################################################
